//#property copyright "Scritong"
//#property link      "scriptong@mail.ru"

//---- input parameters
extern string    A1 = "/  (true)    (false)";
extern bool      OpenCloseTrades = true;   //        
                                            //      
                                            //       .     
                                            //         
                                            //  .      
                                            // ,    Lots  
                                            // TakeProfit  ,      
                                            //        
                                            // Lots    TakeProfit 
                                            //  ,       
                                            //    .  
                                            //      
                                            //     false.     ""
                                            //     .
extern string    A2 = "  ";
extern double    Lots = 0.1;
extern string    A3 = " ATR";
extern int       ATRPeriod = 24;                                //    ATR
extern string    A4 = "  ";
extern int       Range =  2;//       
extern string    A5 = "      ";
extern double    LotExponent = 1.1;                              
extern string    A6 = "   ";
extern int       TakeProfit = 100;     
extern string    A7 = "0 - .  ., 1 - , 2 - , 3 - ";
extern int       MartinMode = 0;
extern string    A8 = "====    =======";
extern string    A8_1 = "  (0-3).    - .";
extern int       CommentCorner = 1;
extern string    A8_2 = "  ";
extern color     BaseColor = Yellow;
extern string    A8_3 = "    ";
extern color     ValueColor = DeepSkyBlue;
extern string    A8_4 = "   ";
extern string    prefix = "OTE_";
extern string    A9 = "===============================================";

extern string    OpenOrderSound = "ok.wav";       //     
extern int       MagicNumber = 11236;           //    

int Signal;                                                             //   

bool Activate, FreeMarginAlert, FatalError, Mode;
double Tick, Spread, StopLevel, MinLot, MaxLot, LotStep, FreezeLevel;
datetime LastBar,                          //     
         BuyLast,                                 //     BUY
         SellLast,                               //     SELL
         LastSignal;                        //     
int BuyTicket[200],                                                 //   BUY
    SellTicket[200],                                               //   SELL
    BuyCount,                                                   //   BUY
    SellCount;                                                 //   SELL
double CommonProfit,       //      / 
       BuyProfit,                                         //    BUY
       SellProfit,                                       //    SELL
       BuyAP,                                                //    BUY
       SellAP,                                              //    SELL
       BuyLots,                                                    //   BUY
       SellLots,                                                  //   SELL
       LotLast,                                        //    
       BuyLow,                                               //    BUY
       BuyHigh,                                             //    BUY
       SellHigh,                                           //    SELL 
       SellLow,                                             //    SELL
       APrice;                               //    

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
int init()
  {
   FatalError = False;
// - 1 - ==      ========================================   
   Tick = MarketInfo(Symbol(), MODE_TICKSIZE);                         //      
   Spread = ND(MarketInfo(Symbol(), MODE_SPREAD)*Point);                 //  
   StopLevel = ND(MarketInfo(Symbol(), MODE_STOPLEVEL)*Point);  //   
   FreezeLevel = ND(MarketInfo(Symbol(), MODE_FREEZELEVEL)*Point);   //  
   MinLot = MarketInfo(Symbol(), MODE_MINLOT);    //    
   MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);   //    
   LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);          //    
// - 1 - ==   =============================================================

// - 2 - ==          =======   
   Lots = LotRound(Lots);                  //     
// - 2 - ==   =============================================================

// - 3 - ========================     ===================
 if (IsTesting())
   {
    Mode = true;     //        
    Print("  !");
    if (IsVisualMode())
      {
       Print("  !");
       Mode = false;    //        
      }
   }
  else
   if (IsOptimization())
     {
      Print("  !");
      Mode = true;   //        
     }
    else
     {
      Print(" !");
      Mode = false;     //        
     } 
// - 3 - =================================   ==============================
//Mode = true;
   LastBar = 0;
   Activate = True; //    ,    

   return(0);
  }
  
//+-------------------------------------------------------------------------------------+
//|                                                       |
//+-------------------------------------------------------------------------------------+
int deinit()
{
 Comment("");
 if (!IsTesting())
   for (int i = ObjectsTotal()-1; i >= 0; i--)
     if (StringSubstr(ObjectName(i), 0, StringLen(prefix)) == prefix)
       ObjectDelete(ObjectName(i));
 return(0);
}
  

//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double LotRound(double L)
{
 return(MathRound(MathMin(MathMax(L, MinLot), MaxLot)/LotStep)*LotStep);
}

//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
double ND(double A)
{
 return(NormalizeDouble(A, Digits));
}  

//+-------------------------------------------------------------------------------------+
//|                                                         |
//+-------------------------------------------------------------------------------------+
string ErrorToString(int Error)
{
 switch(Error)
   {
    case 2: return("  ,   ."); 
    case 5: return("    ,  ."); 
    case 6: return("   ,   ."); 
    case 64: return(" ,   .");
    case 132: return(" ."); 
    case 133: return(" ."); 
    case 149: return(" ."); 
   }
   return(0);
}

//+-------------------------------------------------------------------------------------+
//|   .   ,   True,  - False    |
//+-------------------------------------------------------------------------------------+  
bool WaitForTradeContext()
{
 int P = 0;
 //  ""
 while(IsTradeContextBusy() && P < 5)
   {
    P++;
    Sleep(1000);
   }
 // -------------  
 if(P == 5)
   return(False);
 return(True);    
}

//+-------------------------------------------------------------------------------------+
//| ""                                                         |
//|    OpenOrder            |
//| :                                                                         |
//|   0 -                                                                      |
//|   1 -                                                                 |
//|   2 -   Price                                                         |
//|   3 -   SL                                                            |
//|   4 -   TP                                                            |
//|   5 -   Lot                                                           |
//+-------------------------------------------------------------------------------------+
int OpenOrderCorrect(int Type, double Lot, double Price, double SL, double TP, 
                     bool Redefinition = True)
// Redefinition -  True     
//                 False -  
{
// - 1 - ==     ====================================
 if(AccountFreeMarginCheck(Symbol(), OP_BUY, Lot) <= 0 || GetLastError() == 134) 
  {
   if(!FreeMarginAlert)
    {
     Print("    . Free Margin = ", 
           AccountFreeMargin());
     FreeMarginAlert = True;
    } 
   return(5);  
  }
 FreeMarginAlert = False;  
// - 1 - ==   =============================================================

// - 2 - ==   Price, SL  TP    ====================   
 RefreshRates();
 switch (Type)
   {
    case OP_BUY: 
                string S = "BUY"; 
                if (MathAbs(Price-Ask)/Point > 3)
                  if (Redefinition) Price = ND(Ask);
                  else              return(2);
                if (ND(TP-Bid) <= StopLevel && TP != 0)
                  if (Redefinition) TP = ND(Bid+StopLevel+Tick);
                  else              return(4);
                if (ND(Bid-SL) <= StopLevel)
                  if (Redefinition) SL = ND(Bid-StopLevel-Tick);
                  else              return(3);
                break;
    case OP_SELL: 
                 S = "SELL"; 
                 if (MathAbs(Price-Bid)/Point > 3)
                   if (Redefinition) Price = ND(Bid);
                   else              return(2);
                 if (ND(Ask-TP) <= StopLevel) 
                   if (Redefinition) TP = ND(Ask-StopLevel-Tick);
                   else              return(4);
                 if (ND(SL-Ask) <= StopLevel && SL != 0)
                   if (Redefinition) SL = ND(Ask+StopLevel+Tick);
                   else              return(3);
                 break;
    case OP_BUYSTOP: 
                    S = "BUYSTOP";
                    if (ND(Price-Ask) <= StopLevel)
                      if (Redefinition) Price = ND(Ask+StopLevel+Tick);
                      else              return(2);
                    if (ND(TP-Price) <= StopLevel && TP != 0)
                      if (Redefinition) TP = ND(Price+StopLevel+Tick);
                      else              return(4);
                    if (ND(Price-SL) <= StopLevel)
                      if (Redefinition) SL = ND(Price-StopLevel-Tick);
                      else              return(3);
                    break;
    case OP_SELLSTOP: 
                     S = "SELLSTOP";
                     if (ND(Bid-Price) <= StopLevel)
                       if (Redefinition) Price = ND(Bid-StopLevel-Tick);
                       else              return(2);
                     if (ND(Price-TP) <= StopLevel)
                       if (Redefinition) TP = ND(Price-StopLevel-Tick);
                       else              return(4);
                     if (ND(SL-Price) <= StopLevel && SL != 0)
                       if (Redefinition) SL = ND(Price+StopLevel+Tick);
                       else              return(3);
                     break;
    case OP_BUYLIMIT: 
                     S = "BUYLIMIT";
                     if (ND(Ask-Price) <= StopLevel)
                      if (Redefinition) Price = ND(Ask-StopLevel-Tick);
                      else              return(2);
                     if (ND(TP-Price) <= StopLevel && TP != 0)
                       if (Redefinition) TP = ND(Price+StopLevel+Tick);
                       else              return(4);
                     if (ND(Price-SL) <= StopLevel)
                       if (Redefinition) SL = ND(Price-StopLevel-Tick);
                       else              return(3);
                     break;
    case OP_SELLLIMIT: 
                     S = "SELLLIMIT";
                     if (ND(Price - Bid) <= StopLevel) 
                       if (Redefinition) Price = ND(Bid+StopLevel+Tick);
                       else              return(2);
                     if (ND(Price-TP) <= StopLevel)
                       if (Redefinition) TP = ND(Price-StopLevel-Tick);
                       else              return(4);
                     if (ND(SL-Price) <= StopLevel && SL != 0)
                       if (Redefinition) SL = ND(Price+StopLevel+Tick);
                       else              return(3);
                     break;
   }
// - 2 - ==   =============================================================
 
// - 3 - ==       =================================   
 if(WaitForTradeContext())  //    
   {  
    Comment("     ", S, " ...");  
    int ticket=OrderSend(Symbol(), Type, Lot, Price, 3, 
               SL, TP, NULL, MagicNumber, 0);//  
    //     
    if(ticket<0)
      {
       int Error = GetLastError();
       if(Error == 2 || Error == 5 || Error == 6 || Error == 64 
          || Error == 132 || Error == 133 || Error == 149)     //   
         {
          Comment("     . . "+
                   ErrorToString(Error)+"  !");
          FatalError = True;
         }
        else 
         Comment("   ", S, ": ", Error);       //  
       return(1);
      }
    // ---------------------------------------------
    
    //      
    Comment(" ", S, "  !"); 
    PlaySound(OpenOrderSound); 
    return(0); 
    // ------------------------
   }
  else
   {
    Comment("     !");
    return(1);  
   } 
// - 3 - ==   =============================================================
}

//+-------------------------------------------------------------------------------------+
//|                                                |
//+-------------------------------------------------------------------------------------+
double NP(double A)
{
 return(MathRound(A/Tick)*Tick);
}  

//+-------------------------------------------------------------------------------------+
//|                                                     |
//+-------------------------------------------------------------------------------------+
void GetSignal(int Num)
{
 Signal = 0;
 
// - 1 - ============       ===========
 double ATR1 = iATR(NULL, 0, ATRPeriod, Num);         //    R
 double ATR2 = iATR(NULL, 0, ATRPeriod, Num+1);   //    ATR
 double ATR3 = iATR(NULL, 0, ATRPeriod, Num+2);//   ATR
 double Curr1 = High[Num] - Low[Num];                       //   
 double Curr2 = High[Num+1] - Low[Num+1];                   //   
 double Curr3 = High[Num+2] - Low[Num+2];                  //   
// - 1 - ==========================   =====================================

 if (Curr1 > ATR1 && Curr2 < ATR2 && Curr3 <= ATR3)//   
   {                          //       
// - 2 - ========================    =============================
    if (Open[Num] > Close[Num] &&                                       //  
        Close[Num] < (High[Num] + Low[Num])/2)                 //   
      if (iLowest(NULL, 0, MODE_LOW, Range, Num) == Num &&   //  -  
          High[Num] < High[Num+1])           //     
        {
         Signal = 1;                                                    //  
         LastSignal = Time[0];                     //    
        } 
// - 2 - ==========================   =====================================

// - 3 - ========================    =============================
    if (Open[Num] < Close[Num] &&                                          //  
       Close[Num] > (High[Num] + Low[Num])/2)                  //   
      if (iHighest(NULL, 0, MODE_HIGH, Range, Num) == Num &&//  -  
          Low[Num] > Low[Num+1])               //     
        {
         Signal = -1;                                                   //  
         LastSignal = Time[0];                     //    
        } 
// - 3 - ==========================   =====================================
   }
}

//+-------------------------------------------------------------------------------------+
//|   .                                                                |
//+-------------------------------------------------------------------------------------+
void FindOrders()  
{
// - 1 - =====================   =================================
 BuyCount = 0; SellCount = 0;                            //   BUY  SELL
 BuyAP = 0; SellAP = 0;                     //      
 BuyLots = 0; SellLots = 0;                       //     
 BuyLast = 0; SellLast = 0;         //      BUY  SELL
 LotLast = 0;                                                  //   
 BuyLow = 99999999999; SellHigh = 0;                  //   BUY   SELL
 BuyHigh = 0; SellLow = 999999999;                    //   BUY   SELL
 CommonProfit = 0;                                                   //  
 BuyProfit = 0; SellProfit = 0;           //   BUY    SELL
// - 1 - ==========================   =====================================

// - 2 - ===================================   ==============================
 for (int i = 0; i < OrdersTotal(); i++)              //    
   if (OrderSelect(i, SELECT_BY_POS))                       // ,   
     if ((OrderMagicNumber() == MagicNumber ||                  //   
          !OpenCloseTrades) &&                       //     
         OrderSymbol() == Symbol())    //      
       {  
        CommonProfit += OrderProfit()+OrderSwap();         //   
        LotLast = MathMax(LotLast, OrderLots());              //   
        if (OrderType() == OP_BUY)                                     //   BUY
          {
           BuyTicket[BuyCount] = OrderTicket();                      //  
           BuyLots += OrderLots();                                      //  
           BuyAP += OrderLots()*OrderOpenPrice();              //   
           BuyLast = MathMax(BuyLast, OrderOpenTime());     //   
           BuyLow = MathMin(BuyLow, OrderOpenPrice());                      //  BUY
           BuyHigh = MathMax(BuyHigh, OrderOpenPrice());                   //  BUY
           BuyProfit += OrderProfit()+OrderSwap();                     //  
           BuyCount++;                                                  //  BUY
          }
        if (OrderType() == OP_SELL)
          {
           SellTicket[SellCount] = OrderTicket();                    //  
           SellLots += OrderLots();                                     //  
           SellAP += OrderLots()*OrderOpenPrice();             //   
           SellLast = MathMax(SellLast, OrderOpenTime());   //   
           SellHigh = MathMax(SellHigh, OrderOpenPrice());                //  SELL
           SellLow = MathMin(SellLow, OrderOpenPrice());                   //  SELL
           SellProfit += OrderProfit()+OrderSwap();                    //  
           SellCount++;                                                //  SELL
          }
       } 
// - 2 - ==========================   =====================================

// - 3 - ==================     ========================
 if (BuyLots != 0)       //    BUY,      
   BuyAP /= BuyLots;      

 if (SellLots != 0)     //    SELL,      
   SellAP /= SellLots;      

 if (NormalizeDouble(MathAbs(BuyLots - SellLots), 3) != 0)//    
   {                                          //     
    APrice = (BuyAP*BuyLots - SellLots*(SellAP - Spread))/(BuyLots - SellLots);  
    if (BuyLots > SellLots)                                   //   BUY - 
      APrice = MathCeil(APrice/Tick)*Tick;
     else                                                     //   SELL - 
      APrice = MathFloor(APrice/Tick)*Tick;
    if (BuyCount == 0)       //    BUY,     
      APrice = SellAP;                                                   //   
    if (SellCount == 0)     //    SELL,     
      APrice = BuyAP;                                                    //   
   } 
// - 3 - ==========================   =====================================
}    

//+-------------------------------------------------------------------------------------+
//|   BUY                                                                |
//+-------------------------------------------------------------------------------------+
bool CloseAllBuy()
{
 for (int i = BuyCount-1; i >= 0; i--)
   if (OrderSelect(BuyTicket[i], SELECT_BY_TICKET) && OrderCloseTime() == 0)
     if (WaitForTradeContext())
       if (!OrderClose(OrderTicket(), OrderLots(), NP(Bid), 3))
         return(False);
 return(True);         
}

//+-------------------------------------------------------------------------------------+
//|   SELL                                                               |
//+-------------------------------------------------------------------------------------+
bool CloseAllSell()
{
 for (int i = SellCount-1; i >= 0; i--)
   if (OrderSelect(SellTicket[i], SELECT_BY_TICKET) && OrderCloseTime() == 0)
     if (WaitForTradeContext())
       if (!OrderClose(OrderTicket(), OrderLots(), NP(Ask), 3))
         return(False);
 return(True);        
}

//+-------------------------------------------------------------------------------------+
//|                                                                      |
//+-------------------------------------------------------------------------------------+
bool Trade()
{
// - 1 - ====================    ==================================
 if (Signal > 0 && BuyLast < Time[0] &&     //  BUY,      
     ((Ask < BuyLow && MartinMode < 2) ||  //    Ask    BUY
                                                                                   // 
      (Ask > BuyHigh && (MartinMode == 0 || MartinMode == 2)) ||  //    Ask
                                                                     //   BUY
                                                                                   // 
      MartinMode == 3))                                              //  
   {
    if (MartinMode == 3 && Ask < SellAP)   //     
      {             //   SELL.     ,  
       if (!CloseAllSell())                              //    SELL
         return(False);                                   //    
       FindOrders();                      //     
      }   
    if (LotLast == 0)            //     .  , 
      double Lot = Lots;                                             //  - 
     else 
      Lot = LotRound(LotLast*LotExponent);      //     
    OpenOrderCorrect(OP_BUY, Lot, NP(Ask), 0, 0);                  //   BUY
    return(False);                                 //     
   } 
// - 1 - ====================   ===========================================
           
// - 2 - ====================    =================================
 if (Signal < 0 && SellLast < Time[0] &&   //  SELL,      
     ((Bid > SellHigh && MartinMode < 2) ||     //    Bid   SELL
                                                                                   // 
      (Bid < SellLow && (MartinMode == 0 || MartinMode == 2)) ||  //    Bid
                                                                     //   SELL
                                                                                   // 
      MartinMode == 3))                                              //  
   {
    if (MartinMode == 3 && Bid > BuyAP)    //     
      {              //   BUY.     ,  
       if (!CloseAllBuy())                                //    BUY
         return(False);                                   //    
       FindOrders();                      //     
      }   
    if (LotLast == 0)            //     .  , 
      Lot = Lots;                                                    //  - 
     else 
      Lot = LotRound(LotLast*LotExponent);      //     
    OpenOrderCorrect(OP_SELL, Lot, NP(Bid), 0, 0);                //   SELL
    return(False);                                 //     
   } 
// - 2 - ====================   ===========================================
 
 return(True);    
}

//+-------------------------------------------------------------------------------------+
//|                                                   |
//+-------------------------------------------------------------------------------------+
bool ModifyCheck()
{
// - 1 - =======================    ? ========================
 if (NormalizeDouble(MathAbs(BuyLots - SellLots), 3) == 0) //     
   return(True);                           //   ,   
// - 1 - =============================   ==================================
  
 double NomTake = TakeProfit*Lots;      //  ,   
                                        //  TakeProfit       
                                        // Lots (   ,  
                                        //    )
  
// - 2 - =====   - BUY.    BUY    SELL =====
 if (BuyLots > SellLots)
   {
    double PriceTP = APrice + NomTake/(BuyLots - SellLots)*Point;//   
    
    // - 2.1 - ===================     SELL ==================
    for (int i = 0; i < SellCount; i++)          //     SELL
      if (OrderSelect(SellTicket[i], SELECT_BY_TICKET) &&   // ,   
          OrderCloseTime() == 0)                                           //   
        if (MathAbs(OrderStopLoss() - (PriceTP + Spread)) >= Tick)//   
          if (WaitForTradeContext())                       //    ?
            {
             RefreshRates();                                //   Bid  Ask
             if (PriceTP + Spread - Ask > StopLevel) //     
               if (!OrderModify(OrderTicket(), 0, NP(PriceTP + Spread), 0, 0))// 
                 return(False);                     //     
            }
    // - 2.1 - ==========================   ===============================
    
    // - 2.2 - ================     BUY ====================
    for (i = 0; i < BuyCount; i++)                //     BUY
      if (OrderSelect(BuyTicket[i], SELECT_BY_TICKET) &&    // ,   
          OrderCloseTime() == 0)                                           //   
        if (MathAbs(OrderTakeProfit() - PriceTP) >= Tick)      //    
          if (WaitForTradeContext())                       //    ?
            {
             RefreshRates();                                //   Bid  Ask
             if (PriceTP - Bid > StopLevel)          //     
               if (!OrderModify(OrderTicket(), 0, 0, NP(PriceTP), 0, 0))      // 
                 return(False);                     //     
            }
    // - 2.2 - ==========================   ===============================
   } 
// - 2 - =============================   ==================================
      
// - 3 - =====   - SELL.    SELL    BUY ====
 if (BuyLots < SellLots)  
   {
    if (BuyLots == 0)    //    ,       
      PriceTP = APrice - NomTake/SellLots*Point - Spread;        //   
     else 
      PriceTP = APrice - NomTake/(SellLots - BuyLots)*Point;     //   

    // - 3.1 - ===================     BUY ===================
    for (i = 0; i < BuyCount; i++)                //     BUY
      if (OrderSelect(BuyTicket[i], SELECT_BY_TICKET) &&    // ,   
          OrderCloseTime() == 0)                                           //   
        if (MathAbs(OrderStopLoss() - PriceTP) >= Tick)          //    
          if (WaitForTradeContext())                       //    ?
            {
             RefreshRates();                                //   Bid  Ask
             if (Bid - PriceTP > StopLevel)          //     
               if (!OrderModify(OrderTicket(), 0, NP(PriceTP), 0, 0))         // 
                 return(False);                     //     
            }
    // - 3.1 - ==========================   ===============================

    // - 3.2 - ================     SELL ===================
    for (i = 0; i < SellCount; i++)              //     SELL
      if (OrderSelect(SellTicket[i], SELECT_BY_TICKET) &&   // ,   
          OrderCloseTime() == 0)                                           //   
        if (MathAbs(OrderTakeProfit() - (PriceTP + Spread)) >= Tick)   //   
                                                                       // 
          if (WaitForTradeContext())                       //    ?
            {
             RefreshRates();                                //   Bid  Ask
             if (Ask - (PriceTP + Spread) > StopLevel)//    
               if (!OrderModify(OrderTicket(), 0, 0, NP(PriceTP + Spread), 0))// 
                 return(False);                     //     
            }
    // - 3.2 - ==========================   ===============================
   }
// - 3 - =============================   ==================================
      
 return(True);                         //     -  True 
}

//+-------------------------------------------------------------------------------------+
//|   /                                    |
//+-------------------------------------------------------------------------------------+
void SetLabel(string ObjName,                                              //  
              int X, int Y,                  //    Y    
              int Font,      //  : 0 - Windings, 1 - MS Sans Serif, 2 - Fixedsys
              int FontSize,                                              //  
              string Text,                                                 //  
              color Color)                                                  //  
{
 string name = prefix + ObjName;  //       
                                  // 
 switch (Font)                                    //      
   {
    case 0: string FontName = "Courier"; break;
    case 1: FontName = "MS Sans Serif"; break;
    case 2: FontName = "Fixedsys"; break;
   } 
 if (ObjectFind(name) < 0)                     //      , 
   {
    ObjectCreate(name, OBJ_LABEL, 0, 0, 0);                           //  
    ObjectSet(name, OBJPROP_CORNER, CommentCorner);          //   
   }
 ObjectSet(name, OBJPROP_XDISTANCE, X);                      //   
 ObjectSet(name, OBJPROP_YDISTANCE, Y);                        //   
 ObjectSetText(name, Text, FontSize, FontName, Color);//   
                                                      //  
}

//+-------------------------------------------------------------------------------------+
//|                                              |
//+-------------------------------------------------------------------------------------+
void ShowTable(int XUPS, int YUPS,                            //   
               int XHL, int YHL,                              //   
               int XCP, int YCP,                      //   " "
               int XBCP, int YBCP,              //     BUY
               int XSCP, int YSCP,             //     SELL
               int XAP, int YAP,                        //    
               int XAL, int YAL,                              //   
               int XAPr, int YAPr,                  //    
               int XSS, int YSS,                         //   
               int XHL2, int YHL2,                     //    
               int XBUY, int YBUY,               //   BUY  
               int XBAm, int YBAm,                   //    BUY
               int XBP, int YBP,                  //     BUY
               int XBL, int YBL,                          //    BUY
               int XBPr, int YBPr,                     //     BUY
               int XSELL, int YSELL,            //   SELL  
               int XSAm, int YSAm,                  //    SELL
               int XSP, int YSP,                 //     SELL
               int XSL, int YSL,                         //    SELL
               int XSPr, int YSPr,                    //     SELL
               int XES, int YES)                     //   
{
// - 1 - ==================   -   ========================
    SetLabel("UPSeparator", XUPS, YUPS, 2, 9,  //    - " "
             "=========   ==========", BaseColor);
    SetLabel("HeadLine", XHL, YHL, 1, 9,         //   -   
             "                                                +/-", 
             BaseColor);
    if (NormalizeDouble(MathAbs(BuyLots - SellLots), 3) == 0)  //   
      {                      //   (     ), 
       SetLabel("CommonPos", XCP, YCP, 60, 9, " ", //  
                ValueColor);                                                //  
       if (ObjectFind(prefix + "APrice") == 0)  //     
         ObjectDelete(prefix + "APrice");
       if (ObjectFind(prefix + "ALots") == 0)
         ObjectDelete(prefix + "ALots");
       if (ObjectFind(prefix + "AProfit") == 0)
         ObjectDelete(prefix + "AProfit");
      } 
     else                                           //    
      if (BuyLots > SellLots)                                 //   - BUY
        {
         SetLabel("CommonPos", XBCP, YBCP, 2, 9, "BUY", BaseColor);    //  - "BUY"
         SetLabel("APrice", XAP, YAP, 1, 9, DoubleToStr(APrice, Digits), //  
                  ValueColor);
         SetLabel("ALots", XAL, YAL, 1, 9,                    //   
                  DoubleToStr(BuyLots - SellLots, 2), ValueColor);
         SetLabel("AProfit", XAPr, YAPr, 1, 9, // /    
                  DoubleToStr(CommonProfit, 2), ValueColor);         
        }         
       else                                                  //   - SELL
        {
         SetLabel("CommonPos", XSCP, YSCP, 2, 9, "SELL", BaseColor);  //  - "SELL"
         SetLabel("APrice", XAP, YAP, 1, 9, DoubleToStr(APrice, Digits), //  
                  ValueColor);
         SetLabel("ALots", XAL, YAL, 1, 9,                    //   
                  DoubleToStr(SellLots - BuyLots, 2), ValueColor);
         SetLabel("AProfit", XAPr, YAPr, 1, 9, // /    
                  DoubleToStr(CommonProfit, 2), ValueColor);         
        }         
// - 1 - =============================   ==================================
                           
// - 2 - ==================   -    ==================
    SetLabel("NextSeparator", XSS, YSS, 2, 9,      //     
             "===========   ===========", BaseColor);      
    SetLabel("NextSeparator2", XHL2, YHL2, 1, 9,                  //   
             "           -                            +/-",
             BaseColor);      

    SetLabel("BUY", XBUY, YBUY, 2, 9, "BUY", BaseColor);               //  - "BUY"
    SetLabel("BAmount", XBAm, YBAm, 1, 9,                       //   BUY
             DoubleToStr(BuyCount, 0), ValueColor);
    SetLabel("BPrice", XBP, YBP, 1, 9,               //     BUY
             DoubleToStr(BuyAP, Digits), ValueColor);
    SetLabel("BLots", XBL, YBL, 1, 9,                      //    BUY
             DoubleToStr(BuyLots, 2), ValueColor);         
    SetLabel("BProfit", XBPr, YBPr, 1, 9,         //  /  BUY
             DoubleToStr(BuyProfit, 2), ValueColor);         
    
    SetLabel("SELL", XSELL, YSELL, 2, 9, "SELL", BaseColor);          //  - "SELL"
    SetLabel("SAmount", XSAm, YSAm, 1, 9,                      //   SELL
             DoubleToStr(SellCount, 0), ValueColor);
    SetLabel("SPrice", XSP, YSP, 1, 9,              //     SELL
             DoubleToStr(SellAP, Digits), ValueColor);
    SetLabel("SLots", XSL, YSL, 1, 9,                     //    SELL
             DoubleToStr(SellLots, 2), ValueColor);         
    SetLabel("SProfit", XSPr, YSPr, 1, 9,        //  /  SELL
             DoubleToStr(SellProfit, 2), ValueColor);         

    SetLabel("Separator3", XES, YES, 2, 9, 
             "==================================", BaseColor);       
// - 2 - =============================   ==================================
}               

//+-------------------------------------------------------------------------------------+
//|                                                             |
//+-------------------------------------------------------------------------------------+
void InfoWindow()
{
// - 1 - ========================== ,      ==============
 if (CommentCorner == 0)                                //   -  
   ShowTable(  1,  20,  10,  32, 100,  45,   1,  45,   1,  45,
              80,  45, 165,  45, 230,  45,   1,  60,  10,  72,
               1,  85,  80,  85, 120,  85, 180,  85, 230,  85,
               1, 100,  80, 100, 120, 100, 180, 100, 230, 100,   1, 115);
// - 1 - =============================   ==================================

// - 2 - ========================== ,      =============
 if (CommentCorner == 1)
   ShowTable(  1,  20,  10,  32, 100,  45, 240,  45, 232,  45,
             150,  45,  70,  45,   1,  45,   1,  60,  10,  72,
             240,  85, 190,  85, 120,  85,  70,  85,   1,  85,
             232, 100, 190, 100, 120, 100,  70, 100,   1, 100,  1, 115);
// - 2 - =============================   ==================================

// - 3 - ========================== ,      ===============
 if (CommentCorner == 2)
   ShowTable(  1, 110,  10, 100, 100,  85,   1,  85,   1,  85, 
              80,  85, 165,  85, 230,  85,   1,  68,  10,  57,
               1,  40,  80,  40, 120,  40, 180,  40, 230,  40,
               1,  25,  80,  25, 120, 25,  180,  25, 230,  25,   1,  10);
// - 3 - =============================   ==================================

// - 4 - ========================== ,      ==============
 if (CommentCorner == 3)
   ShowTable(  1, 110,  10, 100,  85,  85, 240,  85, 232,  85,
             150,  85,  70,  85,   1,  85,   1,  68,  10,  57,
             240,  40, 190,  40, 120,  40,  70,  40,   1,  40,
             232,  25, 190,  25, 120,  25,  70,  25,   1,  25,   1,  10);
// - 4 - =============================   ==================================

 WindowRedraw();
}  

//+-------------------------------------------------------------------------------------+
//|  start                                                               |
//+-------------------------------------------------------------------------------------+
int start()
{
// - 1 - ==========================    ? =========================
   if (!Activate || FatalError) return(0);
// - 1 - =============================   ==================================

// - 2 - ==============         ==============
   if (LastBar == Time[0] && Mode)//       
     return(0);                   //  ,    
   FindOrders(); //     ,    
                 // ,      OpenCloseTrades 
   if (!Mode)                //                      
     InfoWindow();        //                
// - 2 - =============================   ==================================

// - 3 - ==========================     =======================
   if (OpenCloseTrades)       //      , 
     if (LastBar == Time[0]) return(0);                                //  
// - 3 - =============================   ==================================
        
// - 4 - ==========================      =================
   if (OpenCloseTrades)                   //      , 
     GetSignal(1);                        //   
// - 4 - =============================   ==================================
   
// - 5 - ==================       =============
   if (OpenCloseTrades)                   //      ,
     if (!Trade()) return(0);             //    
// - 5 - =============================   ==================================

// - 6 - ========          ======
   if (!ModifyCheck()) return(0); 
// - 6 - =============================   ==================================

   LastBar = Time[0];

   return(0);
}


